def array(N1, N2=0,init=0):   #■配列宣言
    if N2==0: return [init for i in range(N1)]
    return [[init for i in range(N2)] for j in range(N1)]
def setGtabX(Stab,NN):#■基準行列設定
    N=len(Stab);Gtab=array(N,N)
    for i in range(N):
        for j in range(N):
            Gtab[i][j]=(Stab[i][j]-1)*NN
    return Gtab

def printMat(S):#■行列の表示
    for i in range(len(S)): print(S[i])
def rightDown(A,N,i):#■右下がりの和
    T=0;
    for j in range(N):T+=A[j][cID(N,i+j)]
    return T
def rightUp(A,N,i):#■右上がりの和
    T=0;
    for j in range(N):T+=A[j][cID(N,i-j)]
    return T
def printSQR(RL):#■魔方陣の表示
    N=len(RL);SDLM="+"+"-"*(N*6+1)+"+"
    print(" "*6+SDLM)   #区切り表示
    for i in range(N):# 魔方陣内数字と横方向の和表示
        S=" "*6+"|";T=0
        for j in range(N):
            S+="%6d"%RL[i][j]; T+=RL[i][j]
        S+=" |%6d"% T
        print(S)
    print("-"*6+SDLM+"-"*6)   #区切り表示
    S="%6d|"% rightUp(RL,N,N-1)
    for j in range(N):# 縦方向の和計算と文字列変換
        T=0
        for i in range(len(RL)):T+=RL[i][j]
        S+="%6d"% T
    S+=" |%6d"% rightDown(RL,N,0)
    print(S)
def cID(N,X):#■枠外ID枠内IDにする
    if   X<0: return X + N
    elif X>=N: return X - N
    return X
def checkComplete(A):
    N=len(A);TT=array(N)
    print("■右下がり方向チェック")
    for i in range(N):TT[i]=rightDown(A,N,i)
    print(TT)
    print("■右上がり方向チェック")
    for i in range(N):TT[i]=rightUp(A,N,i)
    print(TT)


